/*
 * File: Screen_Default_Notes.c
 *
 * Created: Created: Sunday September 2025 21:09:49
 *   Author: Chris
 */


// ============================================================================================
// Includes
#include "../Screens.h"
#include "../UI_Control.h"
#include "../Mode_Manager.h"

#include "../Display.h"
#include "../Display_Objects.h"
#include "../Display_Render_Complex.h"
#include "../Display_Default_Configurations.h"

// ============================================================================================
// Defines


// ============================================================================================
// Variables
static Object_ID _Object_Message_Box;

static const Hierarchical_Menu* _Return_Menu = NULL;
static const Menu_List*         _Return_List = NULL;
static int32_t                  _Return_Selected_Item;

static char*    _Title;
static uint32_t _Title_Length;
static bool     _Bool_Value;
static bool	    _Decision_Made;
static uint32_t	_Counter;


// ============================================================================================
// Function Declarations
void Screen_Setup_Default_Notes(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration, char* title, uint32_t title_length, const Hierarchical_Menu* return_menu, const Menu_List* return_list, int32_t return_selected_item);

static void Screen_Init                (Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration);
static void Screen_Tick                (void);
static void Screen_Click               (uint button_return_value);
static void Screen_Touch_Event         (int16_t x, int16_t y);
static void Screen_Action_CW           (Object_ID object_id);
static void Screen_Action_CCW          (Object_ID object_id);
static void Screen_On_Object_Focused   (Object_ID object_id);
static void Screen_On_Object_Defocused (Object_ID object_id);
static void Screen_On_Object_Select    (Object_ID object_id);
static void Screen_On_Object_Deselect  (Object_ID object_id);


/*******************************************************************
    Functions
*******************************************************************/
void Screen_Setup_Default_Notes(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration, char* title, uint32_t title_length, const Hierarchical_Menu* return_menu, const Menu_List* return_list, int32_t return_selected_item)
{
    _Title = title;
    _Title_Length = title_length;
	_Bool_Value = false;
   
    Screen_Init(direction_out, direction_in, type, frame_duration);

    _Return_Menu = return_menu;
    _Return_List = return_list;
    _Return_Selected_Item = return_selected_item;

    _Decision_Made = false;
    _Counter = 0;
}

void Screen_Init(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration)
{
    _Screen_Last                   = Screen_Init;
    _Screen_Tick                   = Screen_Tick;
    _Screen_Click                  = Screen_Click;
    _Screen_Touch_Event            = Screen_Touch_Event;
    _Screen_Action_CW              = Screen_Action_CW;
    _Screen_Action_CCW             = Screen_Action_CCW;
    _Screen_On_Objects_Focused     = Screen_On_Object_Focused;
    _Screen_On_Objects_Defocused   = Screen_On_Object_Defocused;
    _Screen_On_Object_Select       = Screen_On_Object_Select;
    _Screen_On_Object_Deselect     = Screen_On_Object_Deselect;

    Display_Objects_Clear();
    Display_Screen_Transition_Start(direction_out, direction_in, type, frame_duration);


    //////////////////////////////
    // Add Display Objects here //
    //////////////////////////////
    Display_Render_Complex_Select_YesNo_Set(_Bool_Value, &_Configuration_Default_Select_YesNo);
    Display_Objects_Add_Select_YesNo(_Title, _Title_Length, &_Bool_Value, &_Configuration_Default_Select_YesNo);
    _Object_Message_Box = Display_Objects_Add_Message_Box(CENTER_MIDDLE, BOTH_IN_PERCENT, 50, 50, "Notes Set", MESSAGE_BOX_ICON_CIRCLE_CHECKMARK, &_Message_Box_Style_Regular);

	Display_Select_Object();
}

void Screen_Tick(void)
{
    if(_Decision_Made) {
        _Counter++;
    }

    if(_Counter == MESSAGE_BOX_DEFAULT_TICKS) {
        Screen_Setup_Settings_Hierarchical_Menu(TRANSITION_DOWN, TRANSITION_RIGHT, SCREEN_TRANSITION_DEFAULT_EASING, SCREEN_TRANSITION_DEFAULT_FRAMES, _Return_Menu, _Return_List, _Return_Selected_Item);
    }
}

void Screen_Click(uint button_return_value)
{

}

void Screen_Touch_Event(int16_t x, int16_t y)
{

}

void Screen_Action_CW(Object_ID object_id)
{
    if(_Decision_Made) {
        return;
    }
    
	_Bool_Value = !_Bool_Value;
}

void Screen_Action_CCW(Object_ID object_id)
{
    Screen_Action_CW(object_id);
}

void Screen_On_Object_Focused(Object_ID object_id)
{

}

void Screen_On_Object_Defocused(Object_ID object_id)
{

}

void Screen_On_Object_Select(Object_ID object_id)
{

}

void Screen_On_Object_Deselect(Object_ID object_id)
{
    if(!_Decision_Made) {

        if(_Bool_Value) {
            Mode_Manager_Set_Default_Color_Notes();

            Display_Objects_Show_Message_Box(_Object_Message_Box, MESSAGE_BOX_DEFAULT_TICKS);
        }
        else {
            Screen_Setup_Settings_Hierarchical_Menu(TRANSITION_DOWN, TRANSITION_RIGHT, SCREEN_TRANSITION_DEFAULT_EASING, SCREEN_TRANSITION_DEFAULT_FRAMES, _Return_Menu, _Return_List, _Return_Selected_Item);
        }
        _Decision_Made = true;
    }
}


/*******************************************************************
    Internal Functions
*******************************************************************/

